//
//  ViewController.m
//  07时钟
//
//  Created by 卢鹏肖 on 16/1/12.
//  Copyright © 2016年 gzxzmac. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@property (nonatomic, weak) CALayer *secondLayer;

@property (nonatomic, weak) CALayer *minuteLayer;

@property (nonatomic, weak) CALayer *hourLayer;

@end

@implementation ViewController

/*
 1.添加表盘
 2.添加秒针
 3.旋转秒针
 4.添加分针
 5.旋转分针
 6.添加时针
 7.旋转时针
 */
- (void)viewDidLoad {
    [super viewDidLoad];
    
    
    //1.添加表盘
    [self addWatch];
    //2.添加秒针
    [self addSecond];
    //4.添加分针
    [self addMinute];
    //6.添加时针
    [self addHour];
    //3.旋转秒针
    [self startRun];
    
    // self.view.layer.transform
    
}

#define angle2Arc(angle) (angle * M_PI / 180)

#define secondAngle 6

#define minuteAngle 6

#define hourAngle 30

#define hourMinuteAngle 0.5

//启动定时器
- (void)startRun{
    [NSTimer scheduledTimerWithTimeInterval:1 target:self selector:@selector(rotationLine) userInfo:nil repeats:YES];
}


- (void)rotationLine{
    
    //旋转秒针
    NSCalendar *calender = [NSCalendar currentCalendar];
    NSDateComponents *cmp = [calender components:NSCalendarUnitSecond | NSCalendarUnitMinute | NSCalendarUnitHour fromDate:[NSDate date]];
    NSInteger currentSecond = cmp.second;
    //计算当前要旋转的角度
    NSInteger angle_second = currentSecond * secondAngle;
    //角度转弧度
    CGFloat secondArc = angle2Arc(angle_second);
    //需要围绕Z轴旋转 -- 不累加
    //angle 是弧度
    self.secondLayer.transform = CATransform3DMakeRotation(secondArc, 0, 0, 1);
    /*
     需求:需要旋转的角度
        每一秒要旋转多少度 : 360 / 60 = 6;
     需要:需要获得当前是多少秒
        通过时间工具类来获取
     需求:角度转弧度
        弧度 = angle * M_PI / 180
     需求:就是要让每秒钟调用一次这个方法,让秒针旋转
        通过定时器 NSTimer
     */
    
    // 5.旋转分针
    NSInteger currentMinute = cmp.minute;
    //计算当前要旋转的角度
    NSInteger angle_minute = currentMinute * minuteAngle;
    
    
    //角度转弧度
    CGFloat minuteArc = angle2Arc(angle_minute);
    //旋转分针
    self.minuteLayer.transform = CATransform3DMakeRotation(minuteArc, 0, 0, 1);
    /*
     需求:需要旋转的角度
        每一分钟要旋转多少度 : 360 / 60 = 6;
     */
    
    // 7.旋转时针
    //获得当前的小时数
    NSInteger currentHour = cmp.hour;
    //计算当前要旋转的角度
    NSInteger angle_hour = currentHour * hourAngle;
    //分针带动时针旋转的角度
    NSInteger angle_hour_minute = currentMinute * hourMinuteAngle;
    angle_hour += angle_hour_minute;
    //角度转弧度
    CGFloat hourArc = angle2Arc(angle_hour);
    //旋转分针
    self.hourLayer.transform = CATransform3DMakeRotation(hourArc, 0, 0, 1);
    
    
    /*
     需求:需要旋转的角度
        每一小时要旋转多少度 : 360 / 12 = 30;
     需求:每一分钟都要带动时针旋转一点
        旋转角度 : 30 / 60 = 0.5
     */
}

//6.添加时针
-(void)addHour{
    CALayer *layer = [[CALayer alloc] init];
    layer.bounds = CGRectMake(0, 0, 16, 160);
    //注意:需要把layer显示在屏幕的中心位置
    layer.position = self.view.center;
    //自身位置 因为宽窄高长 x轴是0.5 Y轴是1
    layer.anchorPoint = CGPointMake(0.5, 1);
    layer.backgroundColor = [UIColor blackColor].CGColor;
    [self.view.layer addSublayer:layer];
    self.hourLayer = layer;
}

//4.添加分针
-(void)addMinute{
    CALayer *layer = [[CALayer alloc] init];
    layer.bounds = CGRectMake(0, 0, 10, 180);
    //注意:需要把layer显示在屏幕的中心位置
    layer.position = self.view.center;
    //自身位置 因为宽窄高长 x轴是0.5 Y轴是1
    layer.anchorPoint = CGPointMake(0.5, 1);
    layer.backgroundColor = [UIColor yellowColor].CGColor;
    [self.view.layer addSublayer:layer];
    self.minuteLayer = layer;
}

//2.添加秒针
- (void)addSecond{
    CALayer *layer = [[CALayer alloc] init];
    layer.bounds = CGRectMake(0, 0, 6, 200);
    //注意:需要把layer显示在屏幕的中心位置
    layer.position = self.view.center;
    //自身位置 因为宽窄高长 x轴是0.5 Y轴是1
    layer.anchorPoint = CGPointMake(0.5, 1);
    layer.backgroundColor = [UIColor orangeColor].CGColor;
    [self.view.layer addSublayer:layer];
    self.secondLayer = layer;
}

//1.添加表盘
- (void)addWatch{
    UIImageView *imageView = [[UIImageView alloc] init];
    imageView.bounds = CGRectMake(0, 0, 400, 400);
    imageView.image = [UIImage imageNamed:@"clockBg"];
    [self.view addSubview:imageView];
    imageView.center = self.view.center;
}


@end
